jQuery.namespace("AG.AJAX.OAuth");

/**
 * Makes a request using oauth with jQuery.ajax formatted options.
 *
 * @param options
 */
AG.AJAX.OAuth = function (options) {

    var params;

    options.authorization = "oauth";
    options.useToken = "always";

    params = AG.mapToMakeRequestOptions(options);

    options.send();

    gadgets.io.makeRequest(params.url, function (response) {
        AG.AJAX.OAuth.handleResponse(options, response);
    }, params);
};

/**
 * Handles makeRequest response
 *
 * @param options - ajax settings
 * @param {object} response - makeRequest response  object
 */
AG.AJAX.OAuth.handleResponse = function (options, response) {
    if (response.oauthApprovalUrl) {
        jQuery(document).trigger("ajax.oAuthAvailable", [response.oauthApprovalUrl, options]);
        options.authError();
    } else if (response.rc === 403) {
        options.authError();
    } else {
        AG.AJAX.makeRequestToJQueryAjaxCallbackTransformer(options, response);
    }
};
