jQuery.namespace("AG.AJAX.anonymous");

/**
 * Makes a request using gadgets.io.makeRequest but with jQuery.ajax formatted paramaters
 *
 * @param {object} options - jQuery ajax options
 */
AG.AJAX.anonymous = function (options){

    var params = AG.mapToMakeRequestOptions(options);

    options.send();

    gadgets.io.makeRequest(params.url, function (response) {
        AG.AJAX.anonymous.handleResponse(options, response);
    }, params);
};

/**
 * Handles makeRequest response
 *
 * @param options - ajax settings
 * @param {object} response - makeRequest response  object
 */
AG.AJAX.anonymous.handleResponse = function (options, response) {

    if (response.rc === 401) {
        jQuery(document).trigger("ajax.anonymousAccessDenied", [options]);
    } else {
        AG.AJAX.makeRequestToJQueryAjaxCallbackTransformer(options, response);
        jQuery(document).trigger("ajax.anonymousAccess", [options]);
    }
};
