jQuery.namespace("AG.AJAX.jQuery");

/**
 * Makes request using jQuery.ajax. We use this when the baseURL of the gadget is the same as the containers baseURL.
 *
 * @param {object} options - jQuery ajax options
 */
AG.AJAX.jQuery = function ($ajax){

    // closure to store reference to jQuery.ajax as we override it

    var atlassian = window.atlassian || {};

    return function (options) {

        options.url = AG.getAbsoluteURL(options.url);
        options.global = false; // we handle all jQuery global methods in our overriden jQuery.ajax

        if (typeof atlassian.util === "undefined" || atlassian.util.getRendererBaseUrl() !== options.baseUrl) {
            options.authError();
        } else {
            options.send();
            $ajax(options);
        }
    };

}(jQuery.ajax);
