if (typeof AJS == "undefined" || !AJS) {
    var AJS = {};
}

AJS.test = AJS.test || {};

(function ($) {
    var _existing = false;
    var addScript = function (src) {
        if (!_existing) {
            _existing = {};
            $("head script").each(function() {
                if (this.src) {
                    _existing[this.src] = true;
                }
            });
        }

        if (!_existing[src]) {
            _existing[src] = true;

            var script = makeScriptHtml(src);
//            console.log("attempting to load required resource ", src, script);
            document.write(script);
        } else {
//            console.log("already loaded " + src);
        }
    };

    var makeScriptHtml = function(src) {
        return '<script type="text/javascript" src="' + src + '"></' + 'script>';
    };

    var addScriptsFromHtml = function(html) {
        $(html).each(function() {
            if (this.tagName == "SCRIPT") {
                addScript(this.src);
            }
        });
    };

    var alreadyRequiredResources = {};

    AJS.test.require = function(name) {
        document.write("\n<!--\n\tCalled AJS.test.require(" + name + ")\n-->")
        if (name in alreadyRequiredResources) {
            document.write("\n<!--\n\t" + name + " resources has already been required\n-->")
            return;
        }

        if (name.match(/:/)) {
            document.write("\n<!--\n\t About to make async call for " + name + "\n-->");
            $.ajax({
                dataType: "html",
                async: false, // must be sync because we document.write() in success handler
                url: baseRunnerUrl + "/require?name=" + name,
                success: addScriptsFromHtml
            });
        } else {
            // relative path
            if (!name.match(/^\//)) {
                name = "/" + name;
            }
            name = ".." + name;
            document.write("\n<!--\n\t About to add SCRIPT tag for " + name + "\n-->");            
            addScriptsFromHtml(makeScriptHtml(name));
        }

        alreadyRequiredResources[name] = ""; // indicate that we have already required this so we don't request it again
    };

    AJS.$ = jQuery;
    
})(jQuery);
