[#-- @ftlvariable name="repository" type="com.atlassian.bamboo.plugins.hg.BitbucketRepository" --]

[@ww.textfield labelKey='repository.bitbucket.username' name='repository.bitbucket.username' required=true /]
[#if buildConfiguration.getString('repository.bitbucket.password')?has_content]
    [@ww.checkbox labelKey='repository.password.change' toggle=true name='repository.bitbucket.password.change' /]
    [@ui.bambooSection dependsOn='repository.bitbucket.password.change' showOn=true]
        [@ww.password labelKey='repository.bitbucket.password' name='repository.bitbucket.temporary.password' /]
    [/@ui.bambooSection]
[#else]
    [@ww.hidden name='repository.bitbucket.password.change' value=true /]
    [@ww.password labelKey='repository.bitbucket.password' name='repository.bitbucket.temporary.password' /]
[/#if]

[@ww.select labelKey='repository.bitbucket.repository' name='repository.bitbucket.repository' descriptionKey='repository.bitbucket.repository.description' fieldClass='bitbucket-repository']
    [@ww.param name='disabled' value=!(buildConfiguration.getString('repository.bitbucket.repository')?has_content) /]
    [@ww.param name='extraUtility'][@ui.displayButton id='repository-bitbucket-load-repositories' valueKey='repository.bitbucket.loadRepositories'/][/@ww.param]
    [#if buildConfiguration.getString('repository.bitbucket.repository')?has_content]
        [@ww.param name='headerKey2' value=buildConfiguration.getString('repository.bitbucket.repository') /]
        [@ww.param name='headerValue2']
            [#if buildConfiguration.getString('repository.bitbucket.scm')?has_content]
                ${(buildConfiguration.getString('repository.bitbucket.repository') + ' (' + buildConfiguration.getString('repository.bitbucket.scm')?lower_case + ')')}[#t/]
            [#else]
                ${buildConfiguration.getString('repository.bitbucket.repository')}[#t/]
            [/#if]
        [/@ww.param]
    [/#if]
[/@ww.select]

[@ww.hidden name="repository.bitbucket.scm" toggle=true/]

[@ww.select labelKey='repository.bitbucket.branch' name='repository.bitbucket.branch' descriptionKey='repository.bitbucket.branch.description' fieldClass='bitbucket-branch']
    [@ww.param name='hidden' value=!(buildConfiguration.getString('repository.bitbucket.repository')?has_content) /]
    [#if buildConfiguration.getString('repository.bitbucket.branch')?has_content]
        [@ww.param name='headerKey2' value=buildConfiguration.getString('repository.bitbucket.branch') /]
        [@ww.param name='headerValue2' value=buildConfiguration.getString('repository.bitbucket.branch') /]
    [/#if]
[/@ww.select]

[@ui.bambooSection dependsOn='repository.bitbucket.scm' showOn='GIT']
    [@ww.checkbox labelKey='repository.bitbucket.git.useShallowClones' toggle='true' name='repository.bitbucket.git.useShallowClones' /]
    [#if (plan.buildDefinition.branchIntegrationConfiguration.enabled)!false ]
        [@ui.bambooSection dependsOn='repository.bitbucket.git.useShallowClones']
            [@ui.messageBox type='info' titleKey='repository.bitbucket.git.messages.branchIntegration.shallowClonesWillBeDisabled'/]
        [/@ui.bambooSection]
    [/#if]
[/@ui.bambooSection]

<script type="text/javascript">
(function () {
    var rf = new BAMBOO.BITBUCKET.RepositoryForm({
        repositoryKey: '${repository.key?js_string}',
        repositoryId: ${(repositoryId)!0},
        selectors: {
            repositoryType: '#selectedRepository',
            username: 'input[name="repository.bitbucket.username"]',
            password: 'input[name="repository.bitbucket.temporary.password"]',
            loadRepositoriesButton: '#repository-bitbucket-load-repositories',
            repository: 'select[name="repository.bitbucket.repository"]',
            branch: 'select[name="repository.bitbucket.branch"]',
            bitbucketScm: 'input[name="repository.bitbucket.scm"]'
        }
    });
    rf.init();
}());
</script>
