[#-- @ftlvariable name="action" type="com.atlassian.bamboo.plugins.maven.dependencies.ViewMaven2ChainSummary" --]
[#-- @ftlvariable name="" type="com.atlassian.bamboo.plugins.maven.dependencies.ViewMaven2ChainSummary" --]
<html>
<head>
    [@ui.header pageKey='maven2.summary.title' object=immutablePlan.name title=true /]
    <meta name="tab" content="maven2"/>
    <meta name="decorator" content="plan">
</head>
<body>

<h1>[@ww.text name="maven2.build.submenu.caption"/]</h1>
[@ui.bambooPanel titleKey="maven2.project.dependencyProviderJob" headerWeight='h2']
    [#if dependencyProviderJob?has_content ]
        <p>
        [@ww.text name='maven2.project.dependencyProviderJob.description']
            [@ww.param][@ww.url value='/browse/${dependencyProviderJob.key}' /][/@ww.param]
            [@ww.param]${dependencyProviderJob.name}[/@ww.param]
        [/@ww.text]
        </p>
    [#else ]
        [@ww.text name='maven2.project.dependencyProviderJob.notDefined' /]
    [/#if]
[/@ui.bambooPanel]

[@ui.bambooPanel titleKey="maven2.project.artifactList" headerWeight='h2']

    [#if groupedProjectArtifacts?has_content]
    <table id="maven2ProjectArtifacts" class="gav-grid aui">
        <thead>
            <tr>
                <th width="39%">[@ww.text name='maven2.artifact.artifactId'/]</th>
                <th width="16%">[@ww.text name='maven2.artifact.version'/]</th>
                <th width="45%">[@ww.text name='maven2.artifact.requiredBy'/]</th>
            </tr>
        </thead>
        <tbody>
            [#list groupedProjectArtifacts as groupedArtifacts]
            <tr>
                <td class="gav-header-row" colspan="3"><b>[@ww.text name='maven2.artifact.groupId'/]:</b> ${groupedArtifacts.groupId}</td>
            </tr>
                [#list groupedArtifacts.allArtifacts as artifact]
                <tr>
                    <td class="gav-grid-first-cell">${artifact.artifactId?html}</td>
                    <td>${artifact.version?html}</td>
                    <td>
                        [#list action.getArtifactConsumers(artifact) as plan]
                            <a href="[@ww.url value='/browse/${plan.key}' /]">${plan.name}</a>[#if plan_has_next]
                            <br>[/#if]
                        [/#list]
                    </td>
                </tr>
                [/#list]
            [/#list]
        </tbody>
    </table>
    [#else]
        <p>[@ww.text name="maven2.project.artifactList.none"/]</p>
    [/#if]
[/@ui.bambooPanel]

[@ui.bambooPanel titleKey="maven2.project.dependencyList" headerWeight='h2']
    <p class="headingInfo"><a id="gav-show-all" class="toggleOff">[@ww.text name='maven2.dependencies.showAll'/]</a></p>
    <p class="headingInfo"><a id="gav-show-snapshots" class="toggleOn">[@ww.text name='maven2.dependencies.showOnlySnapshots'/]</a></p>
    [#if groupedProjectDependencies?has_content]
        <table id="maven2ProjectDependencies" class="gav-grid aui">
            <thead>
            <tr>
                <th width="39%">[@ww.text name='maven2.artifact.artifactId'/]</th>
                <th width="16%">[@ww.text name='maven2.artifact.version'/]</th>
                <th width="45%">[@ww.text name='maven2.artifact.providedBy'/]</th>
            </tr>
            </thead>
            [#list groupedProjectDependencies as groupedArtifacts]
                [#if groupedArtifacts.snapshots?has_content]
                <tbody class="gav-tbody-snapshot">
                    <tr>
                        <td class="gav-header-row" colspan="3"><strong>[@ww.text name='maven2.artifact.groupId'/]:</strong> ${groupedArtifacts.groupId}</td>
                    </tr>
                    [#list groupedArtifacts.snapshots as artifact]
                    <tr class="gav-grid-row">
                        <td class="gav-grid-first-cell">${artifact.artifactId?html}</td>
                        <td>${artifact.version?html}</td>
                        <td>
                            [#list action.getArtifactProducers(artifact) as plan]
                                <a href="[@ww.url value='/browse/${plan.key}' /]">${plan.name}</a>[#if plan_has_next]
                                <br>[/#if]
                            [/#list]
                        </td>
                    </tr>
                    [/#list]
                </tbody>
                [/#if]

                [#if groupedArtifacts.releases?has_content]
                <tbody class="gav-tbody-releases">
                    [#if !groupedArtifacts.snapshots?has_content]
                        <tr>
                            <td class="gav-header-row" colspan="3"><strong>[@ww.text name='maven2.artifact.groupId'/]:</strong> ${groupedArtifacts.groupId}</td>
                        </tr>
                    [/#if]

                    [#list groupedArtifacts.releases as artifact]
                    <tr class="gav-grid-row">
                        <td class="gav-grid-first-cell">${artifact.artifactId?html}</td>
                        <td>${artifact.version?html}</td>
                        <td>
                            [#list action.getArtifactProducers(artifact) as plan]
                                <a href="[@ww.url value='/browse/${plan.key}' /]">${plan.name}</a>[#if plan_has_next]
                                <br>[/#if]
                            [/#list]
                        </td>
                    </tr>
                    [/#list]
                </tbody>
                [/#if]
            [/#list]
        </table>
    [#else]
            <p>[@ww.text name="maven2.project.dependencyList.none"/]</p>
    [/#if]
[/@ui.bambooPanel]

<script type="text/javascript">
    enableShowSnapshotsForMaven2Dependencies('#gav-show-all', '#gav-show-snapshots', '#maven2ProjectDependencies', ${action.hasSnapshotDependencies()?string});
</script>
</body>
</html>
