[#-- @ftlvariable name="action" type="com.atlassian.bamboo.jenkins.importer.action.SelectJobsForImport" --]
[#-- @ftlvariable name="action" type="com.atlassian.bamboo.jenkins.importer.action.SelectJobsForImport" --]

[#import "jenkinsCommon.ftl" as jc/]

<html>
<head>
    <title>[@ww.text name='locate.jenkins' /]</title>
    <meta name="step" content="1">
</head>
<body>

[@jc.helpLink/]
<h2>[@ww.text name='locate.jenkins' /]</h2>

[@ww.form action="selectPlansForImport"
    namespace="/admin/jenkinsImport"
    method="POST"
    enctype="multipart/form-data"
    titleKey="jenkins.import.source.header"
    submitLabelKey='jenkins.import.next']

    [#if fn.hasGlobalAdminPermission() ]
        [@ww.select id="methodSelect" labelKey='jenkins.import.method' name='method' list=methods listKey='key' listValue='displayName' toggle=true /]

        [@ui.bambooSection dependsOn='method' showOn='SERVER']
            [@ww.textfield labelKey='jenkins.import.source' name='importSource' cssClass='long-field'/]
        [/@ui.bambooSection]

        [@ui.bambooSection dependsOn='method' showOn='UPLOAD']
            [@fileSelect/]
        [/@ui.bambooSection]
    [#else]
        [#-- restricted admin has no server path option --]
        [@ww.hidden id="methodSelect" name='method' value='UPLOAD'/]
        [@fileSelect/]
    [/#if]

    <script type="text/javascript">
        (function ($, BAMBOO) {
            $("#jenkinsFileUpload").inlineAttach();
        }(jQuery, window.BAMBOO = (window.BAMBOO || {})));
    </script>
[/@ww.form]
</body>
</html>

[#macro fileSelect]
    <div id="max-upload-size" class="hidden">${maxUploadSize}</div>
    [@ww.file id="jenkinsFileUpload" labelKey='jenkins.import.upload' name='jenkinsHomeZipFile' /]
[/#macro]