[#-- @ftlvariable name="" type="com.atlassian.bamboo.jenkins.importer.action.ImportResultSummary" --]
[#-- @ftlvariable name="action" type="com.atlassian.bamboo.jenkins.importer.action.ImportResultSummary" --]
[#-- @ftlvariable name="importReport" type="com.atlassian.bamboo.jenkins.importer.report.ImportReport" --]
[#-- @ftlvariable name="soy" type="com.atlassian.bamboo.ww2.BambooFreemarkerManager.SoyHelper"  --]
[#-- @ftlvariable name="status" type="com.atlassian.bamboo.jenkins.importer.core.result.ImportStatus"  --]

[#import "jenkinsCommon.ftl" as jc/]

<html>
<head>
    <title>[@ww.text name='jenkins.import.results' /]</title>
    <meta name="step" content="3">
</head>
<body>
[#if logFileName?has_content]
    [@ww.url id="logFileDownloadUrl" value="/download/" + logFileName!"" /]
[/#if]

<div id="ji-result-summary">
[@jc.helpLink/]
<h2>[@ww.text name='jenkins.import.results' /]</h2>
    <p id="ji-status">
        [@ww.text name='jenkins.result.planCount']
            [@ww.param value=chainCreationResults.size()/]
            [@ww.param value=singleJobCreationResults.size()/]
            [#if chainCreationResults?has_content && singleJobCreationResults?has_content]
                [@ww.param value=2 /]
            [#else ]
                [@ww.param value=1 /]
            [/#if]
        [/@ww.text]
    </p>
    [#if warningCount > 0 || failureCount > 0]
        <p id="ji-import-results-error-count" class="ji-import-results-error-count">
            [@ww.text name='jenkins.result.errorCount']
                [@ww.param value=warningCount/]
                [@ww.param value=failureCount/]
                [@ww.param value=warningCount + failureCount/]
                [#if warningCount > 0 && failureCount > 0]
                    [@ww.param value=2 /]
                [#else ]
                    [@ww.param value=1 /]
                [/#if]
            [/@ww.text]
        </p>
    [/#if]

    [#if chainCreationResults?has_content]
        <table id="ji-import-results" class="aui ji-import-results">
            <thead>
                <tr>
                    <th>Imported Plan</th>
                    <th class="ji-import-status">Import Status</th>
                    <th>Further Notes</th>
                </tr>
            </thead>
            [#list chainCreationResults as creationResult]
                <tbody class="ji-pipeline">
                    <tr class="ji-import-row-status-${creationResult.status?lower_case} ji-pipeline">
                        <td>${creationResult.chainName}</td>
                        <td class="ji-import-status">${statusLozenge(creationResult.status)}</td>
                        <td></td>
                    </tr>
                    <tr>
                        <th>Imported Job</th>
                        <th class="ji-import-status"></th>
                        <th></th>
                    </tr>
                    [#list creationResult.jobCreationResults as jobResult]
                        [#assign jenkinsJobName=jobResult.jobName/]
                        <tr class="ji-import-row-status-${jobResult.status?lower_case}">
                            <td>${jenkinsJobName?html}</td>
                            <td class="ji-import-status">${statusLozenge(jobResult.status)}</td>
                            <td>[@furtherNotes jobResult/]</td>
                        </tr>
                    [/#list]
                </tbody>
            [/#list]
        </table>
    [/#if]

    [#if singleJobCreationResults?has_content]
        <table id="ji-import-results" class="aui ji-import-results">
            <thead>
                <tr>
                    <th>Imported Plan</th>
                    <th class="ji-import-status">Import Status</th>
                    <th>Further Notes</th>
                </tr>
            </thead>
            <tbody>
                [#list singleJobCreationResults as creationResult]
                    [#assign jobResult=creationResult.jobCreationResults.get(0)/]
                    [#assign jenkinsJobName=jobResult.jobName/]
                    <tr class="ji-import-row-status-${jobResult.status?lower_case}">
                        <td data-ji-component="jenkinsJobName">${jenkinsJobName?html}</td>
                        <td data-ji-component="importStatus" class="ji-import-status">${statusLozenge(jobResult.status)}</td>
                        <td data-ji-component="notes">[@furtherNotes jobResult/]</td>
                    </tr>
                [/#list]
            </tbody>
        </table>
    [/#if]

    ${soy.render("com.atlassian.bamboo.plugins.atlassian-bamboo-jenkins-importer:jenkinsImporterWeb", "ji.page.importResult.importResult", {
        "logFileDownloadUrl": logFileDownloadUrl!""
    })}
</div>

<script>
    (function () {
        new BAMBOO.JENKINS_IMPORTER.IssueCollector({
            trigger: "#ji-import-results-submit-feedback",
            description: "#ji-feedback-description",
            containers: {
                feedbackSubmitConfirmation: "#ji-feedback-submit-confirmation-message-container"
            }
        });
    }());
</script>

</body>
</html>

[#macro logFileLink][#if logFileDownloadUrl??][@ww.text name='jenkins.import.logLink'][@ww.param]${logFileDownloadUrl}[/@ww.param][/@ww.text][/#if][/#macro]

[#macro furtherNotes jobResult]
    [#if jobResult.status='FAIL']
        [#if importReport.failedDueToNoScm(jobResult.jobName)]
            [@ww.text name='jenkins.import.fatal.scm'/] [@logFileLink/]
        [#elseif importReport.failedDueToNoBuilders(jobResult.jobName)]
            [@ww.text name='jenkins.import.fatal.builders'/] [@logFileLink/]
        [#else]
            [@ww.text name='jenkins.import.fatal'/] [@logFileLink/]
        [/#if]
    [#elseif jobResult.status='PARTIAL']
        [#if importReport??]
            [#assign failedPluginCounter = importReport.getUnimportablePluginCount(jobResult.jobName)/]
        [/#if]
        [#if importReport?? && failedPluginCounter > 0]
            [@ww.text name='jenkins.import.warning.plugins']
                [@ww.param value=failedPluginCounter/]
            [/@ww.text] [@logFileLink/]
        [#else]
            [@ww.text name='jenkins.import.warning.other'/] [@logFileLink/]
        [/#if]
    [#else]
        [#if importReport.missingAntCapability(jobResult.jobName)]
            [@ww.text name='ant.capability.missing']
                [@ww.param][@help.href pageKey="capabilities.executables"/][/@ww.param]
            [/@ww.text]
        [#elseif importReport.missingMavenCapability(jobResult.jobName)]
            [@ww.text name='maven.capability.missing']
                [@ww.param][@help.href pageKey="capabilities.executables"/][/@ww.param]
            [/@ww.text]
        [/#if]
    [/#if]
[/#macro]

[#function statusLozenge status]
    [#if status?string == "SUCCESS"]
        [#local colour = "success" /]
    [#elseif status?string == "PARTIAL"]
        [#local colour = "current" /]
    [#elseif status?string == "FAIL"]
        [#local colour = "error" /]
    [/#if]
    [#return soy.render("widget.lozenges.lozenge", {
        "colour": colour,
        "text": status?string,
        "subtle": true
    }) /]
[/#function]