[#-- @ftlvariable name="" type="com.atlassian.bamboo.jenkins.importer.action.SelectJobsForImport" --]
[#-- @ftlvariable name="action" type="com.atlassian.bamboo.jenkins.importer.action.SelectJobsForImport" --]

[#import "jenkinsCommon.ftl" as jc/]

<html>
<head>
    <title>[@ww.text name='job.selection.header' /]</title>
    <meta name="step" content="2">
</head>
<body>

[@jc.helpLink/]
<h2>[@ww.text name='job.selection.header' /]</h2>

[#if !pipelineCreationBeans?has_content && !singleJobCreationBeans?has_content]
    [#if logFileName?has_content]
        [@ww.url id="logFileDownloadUrl" value="/download/" + logFileName!"" /]
    [/#if]
    [@ui.messageBox type="warning"]
        [@ww.text name='jenkins.import.noJobs'/] [#if logFileDownloadUrl??][@ww.text name='jenkins.import.logLink'][@ww.param]${logFileDownloadUrl}[/@ww.param][/@ww.text][/#if]
    [/@ui.messageBox]
[#else]
    <p id="ji-status">
        [@ww.text name='job.selection.header.description']
            [@ww.param value=pipelineCreationBeans?size /]
            [@ww.param value=singleJobCreationBeans?size /]
            [#if pipelineCreationBeans?has_content && singleJobCreationBeans?has_content]
                [@ww.param value=2 /]
            [#else ]
                [@ww.param value=1 /]
            [/#if]
        [/@ww.text]
    </p>

    [@ww.form action="importFromJenkins" namespace="/admin/jenkinsImport" submitLabelKey='jenkins.import.import']
        [#if pipelineCreationBeans?has_content]
            <h2>[@ww.text name='jenkins.pipelines'/]</h2>
            <p>[@ww.text name='jenkins.pipelines.description'/]</p>
            <table id="ji-pipeline-select-table" class="aui ji-plan-select">
                <thead>
                    <tr>
                        <th class="ji-jenkins-name">[@ww.text name='import.pipelines'/]</th>
                        <th class="ji-bamboo-name">[@ww.text name='bamboo.plan.name'/]</th>
                        <th class="ji-plan-enabled">[@ww.text name='bamboo.plan.enabled'/]</th>
                    </tr>
                </thead>
                [#list pipelineCreationBeans as creationBean]
                    <tbody class="ji-pipeline">
                        [@tableRow creationBean.id?string 'ji-pipeline' /]
                        <tr>
                            <th class="ji-jenkins-name">[@ww.text name='import.jobs'/]</th>
                            <th class="ji-bamboo-name">[@ww.text name='bamboo.job.name'/]</th>
                            <th></th>
                        </tr>
                        [#list creationBean.allJobs as jobCreationBean]
                            [@tableRow jobCreationBean.id?string 'ji-job' creationBean.id?string /]
                        [/#list]
                    </tbody>
                [/#list]
            </table>
        [/#if]

        [#if singleJobCreationBeans?has_content]
            <h2>[@ww.text name='jenkins.jobs'/]</h2>
            <p>[@ww.text name='jenkins.jobs.description'/]</p>
            <table id="ji-job-select-table" class="aui ji-plan-select">
                <thead>
                    <tr>
                        <th class="ji-jenkins-name">[@ww.text name='import.jobs'/]</th>
                        <th class="ji-bamboo-name">[@ww.text name='bamboo.plan.name'/]</th>
                        <th class="ji-plan-enabled">[@ww.text name='bamboo.plan.enabled'/]</th>
                    </tr>
                </thead>
                <tbody>
                    [#list singleJobCreationBeans as creationBean]
                        [@tableRow creationBean.id?string 'ji-job' /]
                    [/#list]
                </tbody>
            </table>
        [/#if]
        [@ww.hidden name='importSource'/]
    [/@ww.form]
    <script>
        (function () {
            new BAMBOO.JENKINS_IMPORTER.JobSelector({
                classes: {
                    table: 'ji-plan-select',
                    jobRow: 'ji-job',
                    pipelineRow: 'ji-pipeline',
                    enable: 'ji-enabled',
                    select: 'ji-selected'
                }
            });
        }());
    </script>
[/#if]
</body>
</html>

[#macro tableRow creationBeanId cssClass='' parentCreationBeanId='']
    [#local jenkinsJobName=stack.findString('jenkinsNameMap[${creationBeanId}]')/]
    <tr[#if cssClass?has_content] class="${cssClass}"[/#if][#if parentCreationBeanId?has_content] data-parent="${parentCreationBeanId}"[/#if]>
        <td data-ji-component="enableImport">
            [@ww.checkbox name='selectedJenkinsJobs' id='selectedJenkinsJobs'+creationBeanId fieldValue=creationBeanId label=jenkinsJobName checked=action.isJenkinsJobSelected(creationBeanId)?string cssClass='ji-selected'/]
            [@ww.hidden name='jenkinsJobIds' value=creationBeanId/]
            [@ww.hidden name='jenkinsNameMap[${creationBeanId}]'/]
        </td>
        <td data-ji-component="bambooName">[@ww.textfield name='bambooPlanNameMap[${creationBeanId}]'/]</td>
        <td data-ji-component="enablePlan">[@ww.checkbox name='enabledPlans' id='enabledPlans'+creationBeanId fieldValue=creationBeanId label='Enabled' checked=action.isEnabled(creationBeanId)?string cssClass='ji-enabled'/]</td>
    </tr>
[/#macro]