(function($) {
    function handleDocClick(e) {
        var fancySelects = $('.fancy-select');
        fancySelects.not(fancySelects.has(e.target)).removeClass('active');
    }

    function toggleSelectOptions(e) {
        var target = $(e.target);

        target.closest('.fancy-select').not('.disabled').toggleClass('active');
    }

    function selectOption(e, skipPushState) {
        var target = $(e.target).closest('li'),
                container = target.closest('.fancy-select'),
                selected = container.find('.selected-value li');

        container.removeClass('active');

        // only swap selected value if the value has actually changed
        if (target.attr('data-value') !== selected.attr('data-value')) {
            selected.replaceWith(target.clone());
            container.find('input').val(target.attr('data-value'));
            target.trigger('change', skipPushState);
        }
    }

    $(function() {
        var fancySelects = $('.fancy-select');

        fancySelects.find('.selected-value').live('click', toggleSelectOptions);
        fancySelects.find('ol.options li').live('click', selectOption);
        $(document).bind('click', handleDocClick);
    });
})(AJS.$);