BAMBOO.BrokenBuildTracking = (function ($) {
    var r = {},
        options,
        defaults = {
            containerSelector: null,
            buildKey: null,
            buildNumber: null,
            refreshUrl: null
        },
        loading = {
            add: function () {
                $(options.containerSelector).addClass('loading');
            },
            remove: function () {
                $(options.containerSelector).removeClass('loading');
            }
        };

    r.init = function (opts) {
        options = $.extend(true, defaults, opts);

        $(document).delegate('.take-responsibility, .remove-responsibility', 'click', function (e) {
            e.preventDefault();
            loading.add();
            $.post(this.href, { 'bamboo.successReturnMode': 'json' }).always(r.refresh);
        });
    };

    r.refresh = function () {
        loading.add();
        $.get(options.refreshUrl, {
            buildKey: options.buildKey,
            buildNumber: options.buildNumber
        }).done(function (response) {
            var $newContainer = $(response).filter(options.containerSelector);
            $(options.containerSelector).replaceWith($newContainer);
        }).always(loading.remove);
    };

    return r;
})(AJS.$);