/*
* This file drives the view requests page
*/
(function($) {

    // Wait for UPM to load
    var upmReadyViewRequests = function() {

        // Stop waiting for UPM to load
        $(window).unbind('upmready', upmReadyViewRequests);

        function dismissRequest(pluginKey) {
            var pluginElement = upm.$container.find('input.upm-plugin-key[value="' + pluginKey + '"]').closest('div.upm-plugin'),
                pluginDetails = pluginElement.find('div.upm-details');

            AJS.$.ajax({
                type: 'DELETE',
                url: pluginElement.attr('dismiss-request-link'),
                dataType: 'json',
                complete: function(request, status) {
                    var header = AJS.$('div.upm-plugin-row', pluginElement),
                        success = (status == 'success'),
                        message = AJS.params['upm.messages.request.dismiss.' + (success ? 'success' : 'failure')],
                        messageType = (success ? 'success' : 'error');
                    
                    upm.refreshNotifications();
                    
                    // make the plugin element disappear upon collapse
                    pluginElement.addClass('to-remove');
                    header.click(upm.removeOnCollapse);

                    if (!pluginDetails.hasClass('loaded')) {
                        pluginDetails.bind('detailsLoaded.requestMessage', function() {
                            upm.displayMessage(pluginElement.find('div.upm-message-container'), {
                                body: message,
                                type: messageType
                            });
                            pluginDetails.unbind('detailsLoaded.requestMessage');
                        });

                        upm.togglePluginDetails(pluginElement);
                    } else if (!pluginElement.hasClass('expanded')) {
                        pluginElement.bind('pluginLoaded.requestMessage', function() {
                            upm.displayMessage(pluginElement.find('div.upm-message-container'), {
                                body: message,
                                type: messageType
                            });
                            pluginElement.unbind('pluginLoaded.requestMessage');
                        });

                        upm.togglePluginDetails(pluginElement);
                    } else {
                        upm.displayMessage(pluginElement.find('div.upm-message-container'), {
                            body: message,
                            type: messageType
                        });
                    }
                }
            });
        }

        function showDismissRequestDialog(e) {
            var pluginKey = AJS.$(e.target).closest('.upm-plugin').find('input.upm-plugin-key').val();
            upm.showConfirmDialog(AJS.params['upm.messages.request.dismiss.confirm'], dismissRequest, [ pluginKey ]);
        }

        $('a.upm-dismiss-request', upm.$container).live('click', function(e) {
            e.preventDefault();
            showDismissRequestDialog(e);
        });
    };

    var panelLoadedViewRequests = function() {
        upm.unbind('panelLoaded', panelLoadedViewRequests);
        AJS.$('.upm-no-matching-plugins').text(AJS.params['upm.messages.request.none']);
    };

    $(window).bind('upmready', upmReadyViewRequests);
    upm.bind('panelLoaded', panelLoadedViewRequests);
})(AJS.$);
