[#include "/notification-templates/notificationCommons.ftl"]
[#include "/notification-templates/notificationCommonsHtml.ftl"]

[#macro templateOuter baseUrl showTitleStatus=true statusMessage='' customHeader='']
<html>
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width"/>
    <style type="text/css">
        a:hover, a:focus {
            text-decoration: underline !important;
        }

        @media handheld, only screen and (max-device-width: 480px) {
            div, a, p, td, th, li, dt, dd {
                -webkit-text-size-adjust: auto;
            }

            small, small a {
                -webkit-text-size-adjust: 90%;
            }

            small[class=email-metadata] {
                -webkit-text-size-adjust: 93%;
                font-size: 12px;
            }

            table[id=email-wrap] > tbody > tr > td {
                padding: 2px !important;
            }

            table[id=email-wrap-inner] > tbody > tr > td {
                padding: 8px !important;
            }

            table[id=email-footer] td {
                padding: 8px 12px !important;
            }

            table[id=email-actions] td {
                padding-top: 0 !important;
            }

            table[id=email-actions] td.right {
                text-align: right !important;
            }

            table[id=email-actions] .email-list-item {
                display: block;
                margin: 1em 0 !important;
                word-wrap: normal !important;
            }

            span[class=email-list-divider] {
                display: none;
            }

            .commentsummary small[class=email-metadata] {
                display: block;
            }

            td.comment-avatar {
                padding: 8px 8px 0 8px !important;
            }

            .comment > td + td {
                padding: 8px 8px 8px 0 !important;
            }
        }
    </style>
</head>
<body>
<table id="email-wrap" align="center" cellpadding="0" cellspacing="0" width="100%">
    <tbody>
    <tr>
        <td>
            [#if customHeader?has_content]
                ${customHeader}
            [#else]
                [#if showTitleStatus]
                    [#if buildSummary??]
                        [#if !statusMessage?has_content]
                            [#assign statusText][#if buildSummary.successful]was successful[#else]failed[/#if][/#assign]
                            [#else]
                                [#assign statusText = statusMessage /]
                        [/#if]
                        [@notificationTitleStatus baseUrl=baseUrl status=getBuildStatus(buildSummary) build=buildSummary.plan buildResultKey=buildSummary.planResultKey buildNumber=buildSummary.buildNumber statusMessage=statusText /]
                    [#elseif build?? && buildKey?? && buildNumber??]
                        [@notificationTitleStatus baseUrl=baseUrl status="unknown" build=build buildResultKey=buildKey buildNumber=buildNumber statusMessage=statusMessage /]
                    [/#if]
                [/#if]
            [/#if]

            <table id="email-wrap-inner" cellpadding="0" cellspacing="0" width="100%">
                <tbody>
                <tr>
                    <td>
                        [#nested]
                    </td>
                </tr>
                </tbody>
            </table>
        [@showEmailFooter baseUrl=baseUrl /]
        </td>
    </tr>
    </tbody>
</table>
</body>
</html>
[/#macro]

[#macro userRemovedSentence username usernameWhoUpdated notificationRecipient]
    [#assign userWhoUpdated=bambooUserManager.getBambooUser(usernameWhoUpdated)!/]
    [#assign user=bambooUserManager.getBambooUser(username)!/]
    [#if userWhoUpdated?has_content && usernameWhoUpdated != username]
        [@ui.displayUserFullName user=userWhoUpdated /] has made [#t]
        [#if notificationRecipient?has_content && notificationRecipient==username]
        you [#t]
        [#else]
            [@ui.displayUserFullName user=user /] [#t]
        [/#if]
    no longer responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
    [#else]
        [#if notificationRecipient?has_content && notificationRecipient == username]
        You are no longer responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
        [#else]
            [@ui.displayUserFullName user=user /] is no longer responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
        [/#if]
    [/#if]
[/#macro]

[#macro userAddedSentence username usernameWhoUpdated notificationRecipient]
    [#assign user=bambooUserManager.getBambooUser(username)!/]
    [#assign userWhoUpdated=bambooUserManager.getBambooUser(usernameWhoUpdated)!/]
    [#if userWhoUpdated?has_content && usernameWhoUpdated != username]
        [@ui.displayUserFullName user=userWhoUpdated /] has made [#t]
        [#if notificationRecipient?has_content && notificationRecipient==username]
        you [#t]
        [#else]
            [@ui.displayUserFullName user=user /] [#t]
        [/#if]
    responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
    [#else]
        [#if notificationRecipient?has_content && notificationRecipient == username]
        You have been made responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
        [#else]
            [@ui.displayUserFullName user=user /] has been made responsible for fixing this [#if resultsSummary??]build[#else]plan[/#if].[#lt]
        [/#if]
    [/#if]
[/#macro]