[#-- @ftlvariable name="" type="com.atlassian.bamboo.brokenbuildtracker.ui.ViewTrackingForBuildResult" --]
[#-- @ftlvariable name="action" type="com.atlassian.bamboo.brokenbuildtracker.ui.ViewTrackingForBuildResult" --]
[#import "/lib/resultSummary.ftl" as ps]

[#if !resultsSummary.isOnceOff() && trackingEntry?has_content]
<div class="responsible-summary">
	<h2>[@ww.text name="bbtracker.responsible.header"/] [@ui.icon type='loading' /]</h2>
	[#if trackingEntry.currentResponsibilities?has_content]
		<ul>
			[#list trackingEntry.currentResponsibilities as responsibility]
                [#assign username=responsibility.userName/]
                <li [#if username == (user.name)!]class="selected"[/#if]>
					[#if user??]
						<div class="ops">
							<a href="[@ww.url action='removeUserFromTracking' namespace='/ajax/tracking' newUser=username trackingId=trackingEntry.id planResultKey=resultsSummary.planResultKey.key /]"
							   class="remove-responsibility delete" title="Remove Responsible User"><span class="assistive">[@ww.text name="global.buttons.remove"/]</span></a>
						</div>
					[/#if]
                    [@userAvatarAndLink responsibility.userName 'avatar' true/]
                    <span class="assigned-by">
                        [#if responsibility.userWhoAssigned??]
                            [#if responsibility.userWhoAssigned!=username]
                                [@ww.text name='bbtracker.assignedby.user']
                                    [@ww.param]
                                        [@userAvatarAndLink responsibility.userWhoAssigned/]
                                    [/@ww.param]
                                [/@ww.text]
                            [/#if]
                        [#else]
                            [@ww.text name="bbtracker.assignedby.auto"/]
                        [/#if]
                    </span>
				</li>
			[/#list]
		</ul>
	[#else]
	   <p class="resp-needed">
           [#assign failingSinceBuildNumber = (buildStatusHelper.failingSinceBuild.buildNumber)!/]
           [#if failingSinceBuildNumber?has_content && failingSinceBuildNumber != buildNumber]
               [@ww.text name="bbtracker.responsible.none.failingsince"][@ww.param][@ps.buildResultLink buildKey failingSinceBuildNumber/][/@ww.param][/@ww.text]
	       [#else]
               [@ww.text name="bbtracker.responsible.none"/]
           [/#if]
       </p>
	[/#if]
	[#if user??]
		<div class="aui-toolbar inline">
			<ul class="toolbar-group">
				<li class="toolbar-item">
					<a href="[@ww.url action='addUserDialog' namespace='/ajax/tracking' trackingId=trackingEntry.id planResultKey=resultsSummary.planResultKey.key /]"
					   class="add-responsibility toolbar-trigger" title="[@ww.text name="bbtracker.responsible.add"/]">[@ww.text name="bbtracker.responsible.add"/]</a>
				</li>
                [#assign alreadyTheOnlyResponsible=trackingEntry.currentResponsibilities.size()==1 && trackingEntry.currentResponsibilities.get(0).userName==user.name/]
                [#if !alreadyTheOnlyResponsible]
                    <li class="toolbar-item">
                        <a class="take-responsibility toolbar-trigger"
                            href="[@ww.url action='takeFullResponsibility' namespace='/ajax/tracking' trackingId=trackingEntry.id planResultKey=resultsSummary.planResultKey.key newUser=user.name returnUrl=currentUrl /]"
                            title="[@ww.text name="bbtracker.claim.responsibility"/]">[@ww.text name="bbtracker.claim.responsibility"/]</a>
                    </li>
                [/#if]
			</ul>
		</div>
	[/#if]
</div>
[@ww.url id='refreshUrl' namespace='/ajax/tracking' action='viewTrackingSummary' /]
<script type="text/javascript">
    BAMBOO.BrokenBuildTracking.init({
        containerSelector: '.responsible-summary',
        buildKey: '${buildKey?js_string}',
        buildNumber: ${buildNumber},
        refreshUrl: '${refreshUrl?js_string}'
    });
</script>
[#if user??]
    [@dj.simpleDialogForm
        triggerSelector=".add-responsibility"
        width=500 height=250
        submitCallback="BAMBOO.BrokenBuildTracking.refresh"
    /]
[/#if]
[/#if]

[#macro userAvatarAndLink userLogin cssClass='' showAvatar=false]
    [#assign bambooUser = action.getUserByName(userLogin)!/]
    [#assign avatarSize = "18"/]
    [#if bambooUser.name??]
        [#if showAvatar]
            [@ui.displayUserGravatar userName=bambooUser.name size=avatarSize class=cssClass alt=bambooUser.fullName?html /]
        [/#if]
        <a href="[@ww.url value='/browse/user/${bambooUser.name}'/]">
            [@ui.displayUserFullName user=bambooUser /]
        </a>
    [#else]
        [@ui.displayUserGravatar size=avatarSize class=cssClass alt=userLogin?html /]
        ${userLogin}
    [/#if]
[/#macro]