AJS.$.namespace("AJS.gadget.bamboo");


AJS.gadget.bamboo.getBase64Credentials = function(prefs)
{
    return Base64.encode(prefs.getString("username") + ":" + prefs.getString("password"));
};


AJS.gadget.bamboo.getConfigTheme = function()
{
    // Unlike JIRA we need the min width to be 500 (we need more room)
    if (gadgets.window.getViewportDimensions().width < 500)
    {
        return "gdt top-label";
    }
    else
    {
        return "gdt long-label";
    }
};

AJS.gadget.bamboo.getServerAddress = function (url)
{
    var returnUrl = url.substring(url.indexOf("://") + 3, url.length);
    if (returnUrl.indexOf(":") != -1)
    {
        returnUrl = returnUrl.substring(0, returnUrl.indexOf(":"));
    }

    if (returnUrl.indexOf("/") != -1)
    {
        returnUrl = returnUrl.substring(0, returnUrl.indexOf("/"));
    }
    return returnUrl;
};

AJS.gadget.bamboo.generateFooter = function (baseUrl, user)
{
    var strippedBaseUrl = (baseUrl);
    var baseFooter = AJS.$("<p>").addClass("footerText").addClass("fullyCentered");
    if (user)
    {
        return baseFooter.text("Authenticated as user " + user + " on server " + strippedBaseUrl);
    }
    else
    {
        return baseFooter.text("Connected to ")
                .append(AJS.$("<a/>").attr({href: strippedBaseUrl}).text(strippedBaseUrl));
    }
};

AJS.gadget.bamboo.buildChartDiv = function(baseUrl, jsonResponse)
{
    return AJS.$("<div/>").addClass("bamboo-chart").addClass("fullyCentered")
            .append(AJS.$(jsonResponse.imageMap))
            .append(AJS.$("<img/>").attr(
                {                    
                    src: baseUrl + "/chart?filename=" + jsonResponse.location,
                    width: jsonResponse.width,
                    height: jsonResponse.height,
                    usemap: "#" + jsonResponse.imageMapName
                }
            ));
};

AJS.gadget.bamboo.buildNoPlansSelectedDiv = function(gadget) {
    var $dummy = AJS.$('<div/>');
    AJS.messages.error($dummy, {body: gadget.getMsg("gadget.common.error.noPlansSelected"), closeable: false});
    return $dummy.children();
};

AJS.gadget.bamboo.buildNoBuildResultsForSelectedPlanDiv = function(gadget) {
    var $dummy = AJS.$('<div/>');
    AJS.messages.error($dummy, {body: gadget.getMsg("gadget.common.error.noBuildResultsForPlans"), closeable: false});
    return $dummy.children();
};

AJS.gadget.bamboo.buildNoBuildResultsForPlanDiv = function(gadget, planKey, message) {
    var $dummy = AJS.$('<div/>');
    AJS.messages.error($dummy, {body: (gadget.getMsg("gadget.common.error.noBuildResultsForPlan") + " " + planKey + " [" + message + "]"), closeable: false});
    return $dummy.children();
};


AJS.gadget.bamboo.processBuildMetadata = function(build)
{
    if (build.metadata)
    {
        var metadata = {};
        AJS.$(build.metadata.item).each(function(i, item)
        {
            metadata[item.key] = item.value;
        });

        build.metadata = metadata;
    }
};
