var AG = {};

/**
 * Copies objects without references
 *
 * @param {object} object - to copy
 * @param {boolean} deep - weather to copy objects within object
 * @return {object}
 */
AG.copyObject = function (object, deep) {

    var copiedObject = {};

        AJS.$.each(object, function(name, property) {
            if (typeof property !== "object" || property === null || property instanceof AJS.$) {
                copiedObject[name] = property;
            } else if (deep !== false) {
                copiedObject[name] = AG.copyObject(property, deep);
            }
        });

    return copiedObject;
};

/**
 * Returns if the gadget container is atlassian or not
 *
 * @return {boolean}
 */
AG.isAtlassianContainer = function () {
    return window._args
            && _args().container === "atlassian"
            && typeof atlassian !== "undefined"
            && window.top.AG && window.top.AG.DashboardManager;
};

/**
 * Checks if the url is relative
 *
 * @param {string} url
 */
AG.isRelativeURL = function (url) {
    return !/^(http|https):\/\//.test(url);
};

/**
 * If the url is relative will convert to an absolute URL
 *
 * @param {string} url
 * @return {string}
 */
AG.getAbsoluteURL = function (url) {
    if (AG.isRelativeURL(url)) {
        // this currenly needs to be set in every gadget. We should be injecting this via publisher.
        return jQuery.ajaxSettings.baseUrl + url;
    } else {
        return url;
    }
};